//+------------------------------------------------------------------+
//|                                       Middle_Order_Price_5_1.mq4 |
//|                                                         StSpirit |
//|                                                edited by yuriyfx |
//|                                  http://forum.mql4.com/ru/19491/ |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                         Original version: Middle_Order_Price.mq4 |
//|                                                         StSpirit |
//|                                                                  |
//+------------------------------------------------------------------+

//       
//      .
//    
//     .

#property copyright "StSpirit"
#property link      ""

#property indicator_chart_window

extern color LineColorBuy = Magenta;               //  
extern color LineColorSell = DodgerBlue;           //  
extern int LineWidth = 2;                          // 

extern bool Text_With_Line = true;                 //     
extern string TextBuy="";                          //    Buy
extern string TextSell="";                         //    Sell
extern color TextColorBuy = Magenta;               //     Buy
extern color TextColorSell = DodgerBlue;           //     Sell
extern int FontSize = 8;                           //    

string LineNameBuy = "Middle_Order_Price_Buy";     //  Buy
string TextNameBuy = "Text_MOP_Buy";               //      Buy
string LineNameSell = "Middle_Order_Price_Sell";   //  Sell
string TextNameSell = "Text_MOP_Sell";             //      Sell


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   return(0);
}
  

void OrderMiddleLine(string Name, double Value, string Order_Type)
{
   string objectName = Name;
   
   if(ObjectFind(objectName)!=0)//   
   {
      ObjectCreate(objectName, OBJ_HLINE, 0, 0, Value);
      if ( Order_Type == "BUY" ) ObjectSet(objectName, OBJPROP_COLOR, LineColorBuy);
      if ( Order_Type == "SELL" ) ObjectSet(objectName, OBJPROP_COLOR, LineColorSell);
      ObjectSet(objectName, OBJPROP_WIDTH, LineWidth);
      ObjectSet(objectName, OBJPROP_BACK, true);
   }
   else  //  ,  
   {
      ObjectMove(objectName, 0, Time[0],Value);
   }
   
   return(0);
}


void LineText(string Name, double MOP, string Order_Type)
{
   string objectName = Name;
   
   if(ObjectFind("objectName")!=0)//   
   {
      ObjectCreate(objectName, OBJ_TEXT, 0, Time[5],MOP);
      if ( Order_Type == "BUY" )
      {
         ObjectSetText(objectName, TextBuy, FontSize, "Arial", TextColorBuy); //  
      }
      if ( Order_Type == "SELL" )
      {
         ObjectSetText(objectName, TextSell, FontSize, "Arial", TextColorSell); //  
      }
      ObjectSet(objectName, OBJPROP_BACK, true);
   }
   else  //  ,  
   {
      ObjectMove(objectName, 0, Time[5],MOP);
   }
   
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectDelete(LineNameBuy);
   ObjectDelete(TextNameBuy);
   ObjectDelete(LineNameSell);
   ObjectDelete(TextNameSell);
   Comment("");
   
   return(0);
  }


//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
  double a=0, b=0, price_ask=0, price_bid=0;
  string comment;

   if (OrdersTotal()!=0)
   {
      for (int i = 0; i < OrdersTotal(); i++)
      {
         if (OrderSelect(i, SELECT_BY_POS)==true)
         {
            if (OrderSymbol() == Symbol())
            {
               if (OrderType() == OP_BUY)
               {
                  price_ask = price_ask + OrderOpenPrice() * OrderLots();
                  a = a + OrderLots();
               }
            
               if (OrderType() == OP_SELL)
               {
                  price_bid = price_bid + OrderOpenPrice() * OrderLots();
                  b = b + OrderLots();
               }
            }
         }
      }
   }
      
   if (a==0)
   {
      ObjectDelete(LineNameBuy);
      ObjectDelete(TextNameBuy);
   }
   
   if (b==0)
   {
      ObjectDelete(LineNameSell);
      ObjectDelete(TextNameSell);
   }
   
   if (a!=0)
   {
      OrderMiddleLine(LineNameBuy, price_ask/a, "BUY");
      if (Text_With_Line!=false) LineText(TextNameBuy, price_ask/a, "BUY");
   }
   if (b!=0)
   {
      OrderMiddleLine(LineNameSell, price_bid/b, "SELL");
      if (Text_With_Line!=false) LineText(TextNameSell, price_bid/b, "SELL");
         
   }
   comment="AVERAGE";
   if (a==0 && b==0)
   {
      comment=StringConcatenate(comment,"  :  NONE");
   }
   if (a!=0)
   {
      comment=StringConcatenate(comment,"  :  BUY = ",a," ",DoubleToStr(price_ask/a,6));
         a=0;
         price_ask=0;
   }
   if (b!=0)
   {
      comment=StringConcatenate(comment,"  :   SELL = ",b," ", DoubleToStr(price_bid/b,6));
         b=0;
         price_bid=0;
   }
   Comment(comment);

   return(0);
  }

//+------------------------------------------------------------------+